%define upname loki
%define majorversion 0
Name: %{upname}-lib
Version: 0.1.6
Release: 4%{?dist}
Summary: Loki C++ Library of design patterns and idioms

Group: Development/Libraries
License: MIT
URL: http://sourceforge.net/projects/loki-lib
Source0: http://prdownloads.sourceforge.net/loki-lib/%{upname}-%{version}.tar.gz
Patch0: loki-makefile.patch
Patch1: loki-makefile-test.patch
Patch2: loki-makefile-test-parallel.patch
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig

%description
A C++ library of designs, containing flexible implementations of common design
patterns and idioms.

%package devel
Summary: The Loki C++ headers and development libraries
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: glibc-headers
%description devel
Headers and shared object symlinks for the Loki C++ Library

%package doc
Summary: The Loki C++ html docs
Group: Documentation
%description doc
HTML documentation files for the Loki C++ Library

%prep
%setup -n %{upname}-%{version} -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%{__chmod} -x doc/html/*
%{__rm} doc/html/installdox

%build
%{__make} %{?_smp_mflags} CXXFLAGS="%{optflags}" LDLIBS="-lstdc++ -lc" build-shared
(cd lib && ln -s lib%{upname}.so.%{version} lib%{upname}.so)
(cd lib && ln -s lib%{upname}.so.%{version} lib%{upname}.so.%{majorversion})

%install
%{__rm} -fr %{buildroot}
%{__make} %{?_smp_mflags} -C include prefix=%{buildroot}%{_usr} install
%{__mkdir_p} %{buildroot}%{_libdir}
%{__cp} -a lib/lib%{upname}.* %{buildroot}%{_libdir}

# The testsuite does not work in x86_64
#%check
#%{__make} %{?_smp_mflags} CXXFLAGS="%{optflags}" -C test

%clean
%{__rm} -fr %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc README
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root)
%doc CHANGES
%{_includedir}/*
%{_libdir}/*.so

%files doc
%defattr(-,root,root,-)
%doc doc/html doc/flex doc/yasli

%changelog
* Thu Jul 05 2007 Sergio Pascual <spr@astrax.fis.ucm.es> 0.1.6-4
- Installing libraries in _libdir instead of prefix/lib
* Tue Jul 03 2007 Sergio Pascual <spr@astrax.fis.ucm.es> 0.1.6-3
- Header files in directory loki
* Sun Jul 01 2007 Sergio Pascual <spr@astrax.fis.ucm.es> 0.1.6-2
- Disabled test suite, does not work in x86_64
- Added requires for -devel package
* Tue Jun 26 2007 Sergio Pascual <spr@astrax.fis.ucm.es> 0.1.6-1
- fixed installation of .h files
- fixed version number
* Tue Jun 11 2007 Sergio Pascual <spr@astrax.fis.ucm.es> 0.1.6-0.3
- Removed the unused dependency to libm in the dynamic library
* Mon Jun 11 2007 Sergio Pascual <spr@astrax.fis.ucm.es> 0.1.6-0.2
- Removed the unused dependency to libpthread in the dynamic library
* Thu Jun 07 2007 Sergio Pascual <spr@astrax.fis.ucm.es> 0.1.6-0.1
- Initial fedora rpm release
